/*
   test program for eviofmt.c and eviofmtswap.c

   usage:

       machine 1: type 'cc main.c', then './a.out w', will print data
       machine 2: type 'cc main.c', then './a.out r', will print data, must be identical to machine 1
*/

#include <stdio.h>
#include <string.h>

#include "eviofmt.c"
#include "eviofmtswap.c"

#define PRINT \
    printf("0x%08x 0x%08x 0x%08x - 0x%04x 0x%04x 0x%04x 0x%04x - %f %d %f %d %f %d %f %d - 0x%04x 0x%04x %lld\n", \
      ibuf[0],ibuf[1],ibuf[2], \
	  sbuf[6],sbuf[7],sbuf[8],sbuf[9], \
      fbuf[5],ibuf[6],fbuf[7],ibuf[8],fbuf[9],ibuf[10],fbuf[11],ibuf[12],sbuf[26],sbuf[27], \
      lbuf[7])

int
main(int argc, char **argv)
{
  int i, ret, irec[100];
  long long *lbuf = (long long *)irec;
  float *fbuf = (float *)irec;
  int *ibuf = (int *)irec;
  short *sbuf = (short *)irec;
  char *cbuf = (char *)irec;
  unsigned char ifmt[200];
  int  nfmt;
  int nrec = 17;
  FILE *fd;

  if(argc != 2) exit(0);

  /*char *fmt = "3I,4S,2(2(F,I)),2S,L";*/
  /*char *fmt = "3I,4S,(F,I)";*/
  /*char *fmt = "3I,4S,5I";*/

  /*char *fmt = "3I,4S,3(F,I),F,I,2S,L";*/
  char *fmt = "3I,4S,3(F,I),F,NS,L";

  ibuf[0] = 0x01020304;
  ibuf[1] = 0x05060708;
  ibuf[2] = 0x090A0B0C;

  sbuf[6] = 0x0102;
  sbuf[7] = 0x0304;
  sbuf[8] = 0x0506;
  sbuf[9] = 0x0708;

  fbuf[5] = 123.456;
  ibuf[6] = 123;
  fbuf[7] = 123.456;
  ibuf[8] = 456;
  fbuf[9] = 123.456;
  ibuf[10]= 789;
  fbuf[11]= 123.456;
  ibuf[12]= 2;

  sbuf[26]= 0x1020;
  sbuf[27]= 0x3040;

  lbuf[7] = 123456789123456;


  if(!strncmp(argv[1],"w",1))
  {
    PRINT;

    fd = fopen("test.dat","w");
    fwrite(irec,4,nrec,fd);
    fclose(fd);
  }

  if(!strncmp(argv[1],"r",1))
  {
    fd = fopen("test.dat","r");
    fread(irec,4,nrec,fd);
    fclose(fd);

    if( (nfmt=eviofmt(fmt,ifmt))>0 )
    {
      ret = eviofmtswap(irec,nrec,ifmt,nfmt);
      if(ret) printf("ERROR: eviofmtswap returns %d\n",ret);
	}
    else
	{
      if(nfmt<0) printf("ERROR: eviofmt returns %d\n",nfmt);
	}

    PRINT;
  }

}
